package ws.server;

import java.io.*;
import java.util.*;

import javax.mail.internet.*;
import javax.xml.rpc.server.*; 

public class TestUser implements ServiceLifecycle {
    private ServletEndpointContext wsctx;
    public void init(java.lang.Object context) {
        wsctx = (ServletEndpointContext)context;
    }
    public void destroy() {
    }
    public NameValuePair[] execute(NameValuePair[] arg) {
        Map m = toMap(arg);
        Iterator it = wsctx.getMessageContext().getPropertyNames();
        while(it.hasNext()) {
            String key = (String)it.next();
            Object value = wsctx.getMessageContext().getProperty(key); 
            System.out.println(key + " = " + value);
        }
        try {
            String unpw = b64decode(((String)wsctx.getMessageContext().getProperty("Authorization")).substring(6));
            String un = unpw.substring(0, unpw.indexOf(":"));
            m.put("user", un);
        } catch (Exception ex) {
             // nothing
        }
        m.put("status", "ok");
        return fromMap(m);
    }
    private static NameValuePair[] fromMap(Map m) {
        NameValuePair[] nvp = new NameValuePair[m.size()];
        Iterator it = m.keySet().iterator();
        for(int i = 0; i < nvp.length; i++) {
            nvp[i] = new NameValuePair();
            nvp[i].setName((String)it.next());
            nvp[i].setValue((String)m.get(nvp[i].getName()));
        }
        return nvp;
    }
    private static Map toMap(NameValuePair[] nvp) {
        Map m = new HashMap();
        for(int i = 0; i < nvp.length; i++) {
            m.put(nvp[i].getName(), nvp[i].getValue());
        }
        return m;
    }
    private static String b64decode(String s) throws Exception {
        InputStream is = MimeUtility.decode(new ByteArrayInputStream(s.getBytes()),"base64");
        byte[] b = new byte[100];
        int n = is.read(b);
        return new String(b, 0, n);
    }
}
